import Flutter
import UIKit

public class SwiftUPushPlugin: NSObject, FlutterPlugin {
    
  var cacheRemoteNotificationMessage: [AnyHashable:Any]?
    

    
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "u_push_plugin", binaryMessenger: registrar.messenger())
    let instance = SwiftUPushPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
    
    
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    
    let method: String = call.method;
    switch method {
    case "getCacheMessage":
        break;
    case "UMSetLogEnabled":
        break;
    case "UMSetBadgeClear":
        break;
    case "addTags":
        break;
    case "deleteTags":
        break;
    case "getTags":
        break;
    case "addAlias":
        break;
    case "setAlias":
        break;
    case "deleteAlias":
        break;
    default:
        result(FlutterMethodNotImplemented);
    }
    
    result("iOS " + UIDevice.current.systemVersion)
  }
    
    
    //MARK:通知相关的
    //程序杀死后 收到APNs推送 点击通知栏获取通知详细
    public func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [AnyHashable : Any] = [:]) -> Bool {
        
       // 当被杀死状态收到本地通知时执行的跳转代码
       let remoteNotificationDict = launchOptions[UIApplication.LaunchOptionsKey.remoteNotification];
        print("通知栏消息被点击了:\(remoteNotificationDict ?? "")");
        
        self.cacheRemoteNotificationMessage = remoteNotificationDict as? [AnyHashable : Any];
        
        if #available(iOS 10.0, *) {
            UNUserNotificationCenter.current().delegate = self
        } else {
            // Fallback on earlier versions
        };
        
        return true;
    }
    
}


